package com.testscripts;

import com.thoughtworks.selenium.*;

public class XoscormTest extends SeleneseTestCase {
	// We create our Selenium test case
	public String oacsInstanceUrl = "http://localhost/";
	public String JoeStudentUserId = "24707";
	public String MaryLearnerUserId = "43615";
	public String lmsCreditSupport = "no-credit";

	public void setUp() throws Exception {
		setUp(
				"http://localhost/TestSuite1_2_7/TestSuite/LMSRTE/LMSRTEMain.htm",
				"*iexplore");
	}

	public void fillOutPreliminaryInfo() throws Exception {
		selenium
				.open("http://localhost/TestSuite1_2_7/TestSuite/LMSRTE/LMSRTEMain.htm");
		selenium.selectFrame("instructions");
		selenium.click("continue01");
		// We successfully imported the first SCO
		selenium.click("document.forms['inst'].cpRadio[1]");
		selenium.click("complete1");
		// We successfully imported the second SCO
		selenium.click("document.forms['inst'].cpTwoRadio[1]");
		selenium.click("complete2");
		// We successfully enrolled "Joe Student"
		selenium.click("document.forms['inst'].enroll1[0]");
		selenium.click("continueEnroll1");
		// The user_id of Joe Student
		selenium.type("student1Id", this.JoeStudentUserId);
		selenium.click("complete03");
		// No "credit/no-credit" support
		selenium.click("document.forms['inst'].credit[1]");
		// No "mode" support
		selenium.click("document.forms['inst'].mode[1]");
		selenium.click("creditModeContinue");
		// We successfully enrolled "Mary Learner"
		selenium.click("document.forms['inst'].enroll2[0]");
		selenium.click("continueEnroll2");
		// The user_id of Mary Student
		selenium.type("student2Id", this.MaryLearnerUserId);
		selenium.click("complete04");
	}

	public void testSco(final int nr) throws Exception {
		System.out.println("Testing SCO" + nr);
		if (nr > 1) {
			selenium.selectFrame("relative=top");
		}
		selenium.click("link=LMS Test Suite - SCO " + nr);
		selenium.selectFrame("sxorm-player");
		selenium.waitForFrameToLoad("sxorm-player", "555555");
		/*
		 * new Wait() { public boolean until() { return selenium
		 * .isTextPresent("ADL SCORM Test Course I - SCO #0" + nr + "\");"); }
		 * }.wait("Coudnt start SCO" + nr, 500000, 1000);
		 */

		selenium.waitForCondition(
				"selenium.isTextPresent(\"ADL SCORM Test Course I - SCO #0"
						+ nr + "\");", "500003");

		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"Status:  This SCO Test Completed.\");",
						"500012");
		// Unfortunately, Selenium 1.0.1 cannot handle Alert messages which are
		// created during onload(); This is why we modified the ADL Test Package
		// by
		// removing the unnecessary
		// selenium.getAlert();
	}

	public void specialSco9() throws Exception {
		System.out.println("Testing SCO9");
		selenium.selectFrame("relative=top");
		selenium.click("link=LMS Test Suite - SCO 9");
		selenium.selectFrame("sxorm-player");
		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"ADL SCORM Test Course I - SCO #09\");",
						"300000");
		// Now we have to "manually click some buttons"
		selenium.click("name=Initialize");
		selenium.click("name=finishButton");
		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"Status:  This SCO Test Completed.\");",
						"300000");
	}

	public void testNew() throws Exception {
		fillOutPreliminaryInfo();
		// Start the actual test
		selenium.openWindow(this.oacsInstanceUrl + "register/logout", "logout");
		selenium.openWindow(this.oacsInstanceUrl
				+ "register/?return%5furl=%2fxolrn%2fxoscorm-folders", "scormsession");
		selenium.selectWindow("name=scormsession");
		//selenium.waitForPageToLoad("30000");
	    selenium.waitForCondition("selenium.isTextPresent(\"Email\", \"500003\");", "123456");

		selenium.type("email", "");
		selenium.type("password", "");
		// selenium.click("login:elements:persistent_p:t");
		selenium.click("formbutton:ok");
		selenium.waitForPageToLoad("30001");
		// System.out.println(selenium.getCookieByName("ad_session_id"));
		selenium.click("link=ADL Testcourse 1");
		selenium.waitForPageToLoad("60007");
		//verifyTrue(selenium.isTextPresent("LMS Test Suite - Course 1"));
		verifyTrue(selenium.isTextPresent("LMS Test Suite - SCO 1"));

		testSco(1);
		testSco(2);
		testSco(3);

		// SCO 4
		selenium.selectFrame("relative=top");
		selenium.click("link=LMS Test Suite - SCO 4");
		// selenium.waitForFrameToLoad("sxorm-player", "30003");
		selenium.selectFrame("sxorm-player");
		System.out.println(selenium.getBodyText());

		// verifyTrue(selenium.isTextPresent("ADL SCORM Test Course I - SCO #04"));
		// selenium.getAlert();
		// Logout
		selenium.selectFrame("relative=top");
		selenium.click("link=Logout");
		selenium.waitForPageToLoad("40001");
		// Re-Login
		selenium.open(this.oacsInstanceUrl
				+ "register/?return%5furl=%2fxolrn%2f");
		selenium.waitForPageToLoad("300000");
		selenium.type("email", "");
		selenium.type("password", "");
		selenium.click("formbutton:ok");
		selenium.waitForPageToLoad("40002");
		selenium.click("link=xoscorm_folders");
		selenium.waitForPageToLoad("30002");

		// Re-Enter SCO 4
		selenium.click("link=LMS Test Suite - SCO 4");
		// selenium.waitForFrameToLoad("sxorm-player", "30003");
		selenium.selectFrame("sxorm-player");

		// verifyTrue(selenium.isTextPresent("Status:  This SCO Test Completed."));
		// verifyEquals("Completing testing.  Please launch the next SCO.",
		// selenium.getAlert());

		testSco(5);
		testSco(6);
		testSco(7);
		testSco(8);
		specialSco9();

		// Complete the Course
		selenium.selectWindow("");
		selenium.selectFrame("relative=top");
		selenium.selectFrame("instructions");
		
	
		
		
		selenium.click("name=complete05");
		
		
		
		
		
		
		
		// Now Mary Learner
		selenium.openWindow(this.oacsInstanceUrl + "register/logout", "logout2");
		selenium.openWindow(this.oacsInstanceUrl
				+ "register/?return%5furl=%2fxolrn%2f", "scormsession2");
		selenium.selectWindow("name=scormsession2");


		selenium.type("email", "mary@learner.com");
		selenium.type("password", "");
		// selenium.click("login:elements:persistent_p:t");
		selenium.click("formbutton:ok");
		selenium.waitForPageToLoad("30011");
		
		selenium.click("link=xoscorm2");
		selenium.waitForPageToLoad("60088");
		verifyTrue(selenium.isTextPresent("LMS Test Suite - Course 2"));
		verifyTrue(selenium.isTextPresent("LMS Test Suite Course 2 - SCO 01"));
		
		// SCO2 - 1
		System.out.println("Testing SCO2-1");
		selenium.selectFrame("relative=top");
		selenium.click("link=LMS Test Suite Course 2 - SCO 01");
		selenium.selectFrame("sxorm-player");
		selenium.waitForFrameToLoad("sxorm-player", "500000");
		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"ADL SCORM Test Course II - SCO #01\");",
						"300000");
		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"Status:  This SCO Test Completed.\");",
						"300000");	
		
		// SCO2 - 2
		System.out.println("Testing SCO2-2");
		selenium.selectFrame("relative=top");
		selenium.click("link=LMS Test Suite Course 2 - SCO 02");
		selenium.selectFrame("sxorm-player");
		selenium.waitForFrameToLoad("sxorm-player", "500000");

		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"ADL SCORM Test Course II - SCO #02\");",
						"300000");
		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"Please Log out\");",
						"300000");	
		
		
		// Logout
		selenium.selectFrame("relative=top");
		selenium.click("link=Logout");
		selenium.waitForPageToLoad("40001");
		// Re-Login
		selenium.open(this.oacsInstanceUrl
				+ "register/?return%5furl=%2fxolrn%2f");
		selenium.waitForPageToLoad("300000");
		selenium.type("email", "");
		selenium.type("password", "");
		selenium.click("formbutton:ok");
		selenium.waitForPageToLoad("40002");
		selenium.click("link=xoscorm2");
		selenium.waitForPageToLoad("30002");
		selenium.click("link=LMS Test Suite Course 2 - SCO 02");
		selenium.selectFrame("sxorm-player");
		selenium.waitForFrameToLoad("sxorm-player", "500000");
		selenium
		.waitForCondition(
				"selenium.isTextPresent(\"Status:  This SCO Test Completed.\");",
				"300000");	
	
		
		// SCO2 - 3
		System.out.println("Testing SCO2-3");
		selenium.selectFrame("relative=top");
		selenium.click("link=LMS Test Suite Course 2 - SCO 03");
		selenium.selectFrame("sxorm-player");
		selenium.waitForFrameToLoad("sxorm-player", "500000");
		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"ADL SCORM Test Course II - SCO #03\");",
						"300000");
	
		// Now we have to "manually click some buttons"
		selenium.click("name=Initialize");
		selenium.click("name=finishButton");
		selenium
				.waitForCondition(
						"selenium.isTextPresent(\"Status:  This SCO Test Completed.\");",
						"300000");
		
		
		// Complete the Course
		selenium.selectWindow("");
		selenium.selectFrame("relative=top");
		selenium.selectFrame("instructions");
		selenium.click("name=complete06");
		
				
		

		// Finally, output the results
		selenium.selectWindow("");
		selenium.selectFrame("relative=top");
		selenium.selectFrame("log");
		System.out.println(selenium.getBodyText());
		selenium.waitForPageToLoad("300000");

		// selenium.type("q", "selenium rc");
		// selenium.click("btnG");
		// selenium.waitForPageToLoad("300000");
		// assertTrue(selenium.isTextPresent("* selenium rc"));
		// These are the real test steps
	}
}
